﻿using Syncfusion.SfChart.XForms.WinPhone;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Text;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Markup;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Xamarin.Forms.Platform.WinRT;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641
[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.WP81.CustomRenderer))]
namespace SimpleSample.WP81
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage
    {
        public MainPage()
        {
            this.InitializeComponent();
            new CustomRenderer();
            LoadApplication(new SimpleSample.App());

            this.NavigationCacheMode = NavigationCacheMode.Required;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // TODO: Prepare page for display here.

            // TODO: If your application contains multiple pages, ensure that you are
            // handling the hardware Back button by registering for the
            // Windows.Phone.UI.Input.HardwareButtons.BackPressed event.
            // If you are using the NavigationHelper provided by some templates,
            // this event is handled for you.
        }
    }

    public class TooltipConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, string language)
        {
            if (value == null)
                return String.Empty;

            Syncfusion.UI.Xaml.Charts.ChartSegment seg = value as Syncfusion.UI.Xaml.Charts.ChartSegment;

            Model model = seg.Item as Model;
            return model.Month + ":" + model.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            return value;
        }
    }


   public class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;
        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            chart = e.NewElement as CustomChart;

            Control.Behaviors.Clear();

            foreach (var item in Control.Series)
            {
                item.ShowTooltip = true;

                StringBuilder stringBuilder = new StringBuilder();

                stringBuilder.Clear();
                stringBuilder.Append("<DataTemplate xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" >");
                stringBuilder.Append("<Border Background=\"Yellow\" >");         
                stringBuilder.Append("<Grid  Height=\"50\" >");
                stringBuilder.Append("<Grid.RowDefinitions>");
                stringBuilder.Append("<RowDefinition Height=\"0.5*\" />");
                stringBuilder.Append("<RowDefinition Height=\"0.5*\" />");
                stringBuilder.Append("</Grid.RowDefinitions>");
                stringBuilder.Append("<TextBlock Margin=\"3\" Text=\"{Binding Item.Month}\" FontSize=\"16\" />" );
                stringBuilder.Append("<TextBlock Margin=\"3\" Text=\"{Binding Item.Value}\" FontSize=\"16\" Grid.Row=\"1\" />");
                stringBuilder.Append("</Grid></Border></DataTemplate>");

                item.TooltipTemplate = (DataTemplate)XamlReader.Load(stringBuilder.ToString());
            }
        }
       
    }
}
