using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.Droid;
using Com.Syncfusion.Charts;
using Java.Util;
using Android.Graphics;
using System.Text.RegularExpressions;

[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.Droid.CustomRenderer))]

namespace SimpleSample.Droid
{
    class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;
        protected override void OnElementChanged(Xamarin.Forms.Platform.Android.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            chart = e.NewElement as CustomChart;
            var nativeControl = Control;
            nativeControl.LabelsGenerated += nativeControl_LabelsGenerated;
        }

        void nativeControl_LabelsGenerated(object sender, Com.Syncfusion.Charts.SfChart.LabelsGeneratedEventArgs e)
        {
            IList<ChartPointInfo> infos = e.P1 as IList<ChartPointInfo>;

            ChartTrackballBehaviorExt trackball = chart.ChartBehaviors[0] as ChartTrackballBehaviorExt;

            for (int i = 0; i < infos.Count; i++)
            {
                ChartPointInfo point = infos[i];
                var date = point.ChartDataPoint.GetX();

                int index = point.Series.GetDataPointIndex(trackball.XLocation, trackball.YLocation);
                if (index != -1)
                    point.Label = "Month: " + date.ToString() + "\n Value: " + point.Label;
                else
                    point.Visible = false;
            }
        }
    }
}