﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Syncfusion.SfChart.XForms.WinPhone;
using Xamarin.Forms;
using Syncfusion.UI.Xaml.Charts;
using System.Text;
using System.Windows.Markup;
using Syncfusion.SfChart.XForms;
using System.Windows.Media;

[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.WinPhone.CustomRenderer))]
namespace SimpleSample.WinPhone
{
    public partial class MainPage : global::Xamarin.Forms.Platform.WinPhone.FormsApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
            SupportedOrientations = SupportedPageOrientation.PortraitOrLandscape;
            new CustomRenderer();
            global::Xamarin.Forms.Forms.Init();
            LoadApplication(new SimpleSample.App());
        }
    }

    public class TooltipConverter : DependencyObject, System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
             if (value == null)
                return String.Empty;

            Syncfusion.UI.Xaml.Charts.ChartSegment seg = value as Syncfusion.UI.Xaml.Charts.ChartSegment;

            Model model = seg.Item as Model;
            return model.Month + ":" + model.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }

    }

   
    class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;

        protected override void OnElementChanged(Xamarin.Forms.Platform.WinPhone.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            chart = e.NewElement as CustomChart;

            Control.Behaviors.Clear();

            foreach (var item in Control.Series)
            {
                item.ShowTooltip = true;

                StringBuilder stringBuilder = new StringBuilder();

                 stringBuilder.Clear();
                stringBuilder.Append("<DataTemplate xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                stringBuilder.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                stringBuilder.Append(" xmlns:labelConverter=\"clr-namespace:SimpleSample.WinPhone;assembly=SimpleSample.WinPhone\">");
                stringBuilder.Append("<Border Background=\"Yellow\" >");
                stringBuilder.Append("<Border.Resources>");
                stringBuilder.Append("<labelConverter:TooltipConverter  x:Key=\"tooltip\"/>");
                stringBuilder.Append("</Border.Resources>");
                stringBuilder.Append("<TextBlock Text=\"{Binding Converter={StaticResource tooltip}, ConverterParameter={StaticResource tooltip}}\" />");              
                stringBuilder.Append("</Border></DataTemplate>");
                item.TooltipTemplate = (System.Windows.DataTemplate)XamlReader.Load(stringBuilder.ToString());
            }
        }
    }
}
