﻿using System;
using System.Collections.Generic;
using System.Linq;

using Foundation;
using UIKit;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using Syncfusion.SfChart.iOS;
using Syncfusion.SfChart.XForms;
using System.Diagnostics;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.iOS;
using System.Collections;

namespace SimpleSample.iOS
{
    // The UIApplicationDelegate for the application. This class is responsible for launching the 
    // User Interface of the application, as well as listening (and optionally responding) to 
    // application events from iOS.
    [Register("AppDelegate")]
    public partial class AppDelegate : global::Xamarin.Forms.Platform.iOS.FormsApplicationDelegate
    {
		private SFChart NativeChart;
		private CustomChart FormsChart;

        //
        // This method is invoked when the application has loaded and is ready to run. In this 
        // method you should instantiate the window, load the UI into it and then make the window
        // visible.
        //
        // You have 17 seconds to return from this method, or iOS will terminate your application.
        //
        public override bool FinishedLaunching(UIApplication app, NSDictionary options)
        {
			new SfChartRenderer();
			global::Xamarin.Forms.Forms.Init();
			LoadApplication(new App());

			Xamarin.Forms.Forms.ViewInitialized += (sender, e) =>
			{
				SFChart chart = (e.NativeView as SFChart);

				if(chart != null)
				{
					chart.Delegate = new CustomDelegate(e.View as SfChart);
				}

			};

			return base.FinishedLaunching(app, options);
		}
	}

	public class CustomDelegate : ChartDelegate
	{
		private SfChart formChart;
		public CustomDelegate (SfChart chart):base(chart)
		{
			formChart = chart;
		}

		public override void DidTrackballLabelsGenerate (SFChart chart, NSArray pointsInfo)
		{
			NSMutableArray infos = pointsInfo.MutableCopy () as NSMutableArray;

			int count = (int)infos.Count;

			ChartTrackballBehaviorExt trackball = formChart.ChartBehaviors [0] as ChartTrackballBehaviorExt; 

			for (int i = 0; i < count; i++) 
			{
				SFChartPointInfo point = infos.GetItem<SFChartPointInfo> ((nuint)i);

				int datapointCount = (formChart.Series [(int)chart.IndexOfSeries(point.Series)].ItemsSource as IList).Count + 1;

				int index = point.Series.DataPointIndexAtPoint (new CoreGraphics.CGPoint (trackball.XLocation, trackball.YLocation));

				if (datapointCount != index) 
				{
					point.Label = "Month: " + point.Data.XValue.ToString() + "\nValue: " + point.Label;
				}
				else 
				{
					point.Visible = false;
				}
			}
		}
	}
}
